package cz.muni.pa165.generated.client;

import cz.muni.pa165.generated.client.invoker.ApiClient;
import cz.muni.pa165.generated.client.model.Cat;
import cz.muni.pa165.generated.client.model.HelloResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.math.BigDecimal;

@SpringBootApplication
public class MyServiceClient implements CommandLineRunner {

    private static final Logger log = LoggerFactory.getLogger(MyServiceClient.class);

    public static void main(String[] args) {
        SpringApplication.run(MyServiceClient.class, args);
    }

    @Override
    public void run(String... args) throws Exception {
        log.info("running...");

        MyServiceApi myServiceApi = new MyServiceApi(new ApiClient());

        // call hello
        HelloResponse hello = myServiceApi.hello();
        log.info("hello: {}", hello);

        // call createCat
        Cat cat = myServiceApi.createCat("Lynx lynx", 12, BigDecimal.valueOf(8), true);
        log.info("cat: {}", cat);
    }

}
