package cz.muni.pa165.generated.server;

import cz.muni.pa165.generated.server.api.MyServiceApiDelegate;
import cz.muni.pa165.generated.server.model.Cat;
import cz.muni.pa165.generated.server.model.HelloResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.NativeWebRequest;

import java.math.BigDecimal;
import java.util.List;
import java.util.Optional;

@Component
public class MyServiceServer implements MyServiceApiDelegate {

    private static final Logger log = LoggerFactory.getLogger(MyServiceServer.class);

    @Override
    public ResponseEntity<HelloResponse> hello() {
        log.debug("hello() called");
        return new ResponseEntity<>(new HelloResponse().message("Hello World!"), HttpStatus.OK);
    }

    @Override
    public Optional<NativeWebRequest> getRequest() {
        return MyServiceApiDelegate.super.getRequest();
    }

    @Override
    public ResponseEntity<Cat> createCat(String species, Integer weight, BigDecimal age, Boolean vaccinated) {
        Cat cat = new Cat().species(species)
                           .weight(weight)
                           .age(age)
                           .vaccinated(vaccinated)
                           .furColor(Cat.FurColorEnum.BLACK)
                           .favouriteFoods(List.of("Tuna", "Mouse"));
        log.debug("createCat({},{},{},{}) returns {}", species, weight, age, vaccinated, cat);

        return new ResponseEntity<>(cat, HttpStatus.OK);
    }
}
